/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.cpu.decoder;

import static ru.ispras.microtesk.model.cpu.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.cpu.op.JZ;
import ru.ispras.microtesk.model.IsaPrimitive;
import ru.ispras.microtesk.model.Immediate;

/**
 * The {@code DecoderJZ} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderJZ extends DecoderItem {
  private static DecoderJZ instance = null;

  public static DecoderJZ get() {
    if (null == instance) {
      instance = new DecoderJZ();
    }
    return instance;
  }

  private DecoderJZ() {
    super(
        17,
        true,
        "11100000000000000",
        "11100000000000000"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    IsaPrimitive source = null;
    Immediate target = null;

    if (!matchNextOpc(image, BitVector.valueOf("111", 2, 3))) {
      return null;
    }

    source = (IsaPrimitive) readNextPrimitive(image, DecoderOPRNDL.get());
    if (null == source) {
      return null;
    }

    target = readNextImmediate(image, INDEX);

    return newResult(new JZ(source, target));
  }
}
