/*
 * Copyright (c) Institute for System Programming of the Russian Academy of Sciences
 * All Rights Reserved
 *
 * Institute for System Programming of the Russian Academy of Sciences (ISP RAS)
 * 25 Alexander Solzhenitsyn st., Moscow, 109004, Russia
 * http://www.ispras.ru
 *
 * The present file was automatically generated on the basis of formal specifications.
 * It is distributed under the same terms and conditions as the derived specifications.
 *
 * N.B. PLEASE DO NOT MODIFY THIS FILE.
 */

package ru.ispras.microtesk.model.x86.decoder;

import static ru.ispras.microtesk.model.x86.TypeDefs.*;

import ru.ispras.microtesk.model.decoder.DecoderItem;
import ru.ispras.microtesk.model.decoder.DecoderResult;
import ru.ispras.fortress.data.types.bitvector.BitVector;
import ru.ispras.microtesk.model.data.Type;
import ru.ispras.microtesk.model.x86.op.mov_r16i16;
import ru.ispras.microtesk.model.x86.mode.R16;
import ru.ispras.microtesk.model.x86.mode.IMM16;

/**
 * The {@code DecoderMov_r16i16} class is automatically generated by MicroTESK.
 *
 * @author <a href="mailto:microtesk-support@ispras.ru">MicroTESK</a>
 */
public final class DecoderMov_r16i16 extends DecoderItem {
  private static DecoderMov_r16i16 instance = null;

  public static DecoderMov_r16i16 get() {
    if (null == instance) {
      instance = new DecoderMov_r16i16();
    }
    return instance;
  }

  private DecoderMov_r16i16() {
    super(
        32,
        true,
        "10111000110010000000000000000000",
        "11111000111110000000000000000000"
        );
  }

  public DecoderResult decode(final BitVector image) {
    if (!isOpcMatch(image)) {
      return null;
    }

    resetPosition();

    R16 dst = null;
    IMM16 src = null;

    if (!matchNextOpc(image, BitVector.valueOf("10111", 2, 5))) {
      return null;
    }

    dst = (R16) readNextPrimitive(image, DecoderR16.get());
    if (null == dst) {
      return null;
    }

    if (!matchNextOpc(image, BitVector.valueOf("11001", 2, 5))) {
      return null;
    }

    dst = (R16) readNextPrimitive(image, DecoderR16.get());
    if (null == dst) {
      return null;
    }

    src = (IMM16) readNextPrimitive(image, DecoderIMM16.get());
    if (null == src) {
      return null;
    }

    return newResult(new mov_r16i16(dst, src));
  }
}
